#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=sma.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Description=Konvertiert einen Text in die Morsesprache.
#AutoIt3Wrapper_Res_Fileversion=2.16.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Sprenger120
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <SliderConstants.au3>
#include <Array.au3>
#include <ButtonConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
FileInstall("light.jpg", @TempDir & "\light.jpg", 1)
FileInstall("morse.ini", @TempDir & "\morse.ini", 1)
FileInstall("MorSRes.dll", @TempDir & "\MorSRes.dll", 1)

Global Const $Filever = "2.16"
Global Const $KonfFile = @AppDataDir & "\Sma.ini"
Global Const $ADLIBTime = 200
Global $Abstand_Woerter, $Abstand_Woerter_Label, $Abstand_Zeichen, $Abstand_Zeichen_Label, $Exit, $p_gui
Opt("GUICloseOnESC", 0)
Opt("GUIOnEventMode", 1)

FileChangeDir(@TempDir)
$Res_DLL = _WinAPI_LoadLibrary("MorSRes.dll")

$gui = GUICreate("Sprengers Morse Attacke v." & $Filever, 513, 394, -1, -1)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

$Zieltext = GUICtrlCreateEdit("", 24, 16, 465, 105, BitOR($ES_AUTOVSCROLL, $ES_READONLY), 0)
GUICtrlSetState(-1, $GUI_DISABLE)
$Quelltext = GUICtrlCreateEdit("", 24, 168, 465, 105, BitOR($ES_AUTOVSCROLL, $ES_WANTRETURN, $WS_VSCROLL))


$Play = GUICtrlCreateButton("Wiedergabe", 24, 344, 145, 20)
GUICtrlSetOnEvent($Play, "MorsePlayer")


$write_Wiederholung = GUICtrlCreateButton("Wiederholung", 120, 311, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($write_Wiederholung, "W_Wiederholung")

$write_verstanden = GUICtrlCreateButton("verstanden", 312, 286, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($write_verstanden, "W_verstanden")
$write_Spruchende = GUICtrlCreateButton("Spruchende", 216, 286, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($write_Spruchende, "W_Spruchende")

$Player_Optionen = GUICtrlCreateButton("Optionen", 184, 344, 145, 20, 0)
GUICtrlSetOnEvent($Player_Optionen, "Optionen")

$CopyToClip = GUICtrlCreateButton("In Zwischenablage kopieren", 320, 128, 169, 20, 0)
GUICtrlSetOnEvent($CopyToClip, "CopyMData")


$Spruchanfang = GUICtrlCreateButton("Spruchanfang", 24, 286, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($Spruchanfang, "W_Spruchanfang")
$Pause = GUICtrlCreateButton("Pause", 119, 286, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($Pause, "W_Pause")
$Verkehrsende = GUICtrlCreateButton("Verkehrsende", 406, 286, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($Verkehrsende, "W_Verkehrsende")
$Notruf = GUICtrlCreateButton("(See-)Notruf", 24, 310, 81, 20, $WS_GROUP)
GUICtrlSetOnEvent($Notruf, "W_Notruf")


$Menue_Datei = GUICtrlCreateMenu("&Datei")
$Menue_Optionen = GUICtrlCreateMenuItem("Optionen", $Menue_Datei)
GUICtrlSetOnEvent($Menue_Optionen, "Optionen")
$Menue_About = GUICtrlCreateMenu("&ber")


$About = GUICtrlCreateMenuItem("ber", $Menue_About)
GUICtrlSetOnEvent($About, "About")
GUISetState(@SW_SHOW)

AdlibRegister("Convert", $ADLIBTime)
While 1
	Sleep(10)
WEnd

Func W_Notruf()
	GUICtrlSetData($Quelltext, "%SOS%", 1)
EndFunc   ;==>W_Notruf

Func W_Verkehrsende()
	GUICtrlSetData($Quelltext, "%SK%", 1)
EndFunc   ;==>W_Verkehrsende

Func W_Pause()
	GUICtrlSetData($Quelltext, "%BT%", 1)
EndFunc   ;==>W_Pause

Func W_Spruchanfang()
	GUICtrlSetData($Quelltext, "%KA%", 1)
EndFunc   ;==>W_Spruchanfang


Func W_Spruchende()
	GUICtrlSetData($Quelltext, "%AR%", 1)
EndFunc   ;==>W_Spruchende

Func W_verstanden()
	GUICtrlSetData($Quelltext, "%VE%", 1)
EndFunc   ;==>W_verstanden


Func W_Wiederholung()
	GUICtrlSetData($Quelltext, "%HH%", 1)
EndFunc   ;==>W_Wiederholung


Func About()
	MsgBox(64, "ber Sprengers Morse Attacke", "Sprengers Morse Attacke v." & $Filever & @CRLF & "Coded in Autoit by Sprenger120")
EndFunc   ;==>About

Func _Exit()
	AdlibUnRegister("Convert")
	_WinAPI_FreeLibrary($Res_DLL)
	Exit
EndFunc   ;==>_Exit

Func CopyMData()
	ClipPut(GUICtrlRead($Zieltext))
EndFunc   ;==>CopyMData

Func Convert()
	Local $code
	AdlibUnRegister("Convert")
	$MorseCode = StringLower(GUICtrlRead($Quelltext))
	$MorseCode = StringStripWS($MorseCode, 4)
	$MorseCode = StringStripCR($MorseCode)
	$MorseCode = StringSplit($MorseCode, "", 2)
	For $x = 0 To UBound($MorseCode) - 1
		If $x < UBound($MorseCode) - 1 Then
			If $MorseCode[$x] = "c" And $MorseCode[$x + 1] = "h" Then
				$MorseCode[$x] = "ch"
				_ArrayDelete($MorseCode, $x + 1)
				ReDim $MorseCode[UBound($MorseCode) + 1]
			EndIf
		EndIf
		If $MorseCode[$x] = "" Then $MorseCode[$x] = "ss"
	Next

	For $x = UBound($MorseCode) - 1 To 0 Step -1
		If $MorseCode[$x] = "" Then
			_ArrayDelete($MorseCode, $x)
		Else
			ExitLoop
		EndIf
	Next

	For $x = 0 To UBound($MorseCode) - 1
		$code &= IniRead("morse.ini", "Zeichen", $MorseCode[$x], "") & " "
	Next
	GUICtrlSetData($Zieltext, $code)
	AdlibRegister("Convert", $ADLIBTime)
	$code = StringStripWS($code, 8)
	Return $code
EndFunc   ;==>Convert


Func MorsePlayer()
	Local $Modus
	$MorseCode = Convert()
	AdlibUnRegister("Convert")
	GUISetState(@SW_LOCK, $gui)

	$p_gui = GUICreate("Player", 460, 121, -1, -1, $WS_POPUP, BitOR($WS_EX_TOOLWINDOW, $WS_EX_WINDOWEDGE))
	$Fortschritt = GUICtrlCreateProgress(8, 88, 441, 25)
	$tFortschritt = GUICtrlCreateLabel("0%", 444 / 2 + 8, 94, 21, 17, BitOR($SS_CENTER, $SS_RIGHT, $SS_GRAYFRAME, $SS_WHITEFRAME, $SS_SIMPLE))
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

	$Optisch = GUICtrlCreatePic("", 324, 26, 121, 49, 0)
	$Info = GUICtrlCreateEdit("", 16, 24, 297, 49, $ES_WANTRETURN, 0)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateLabel("Mit Escape abbrechen.", 16, 0, 114, 17)
	GUISetState(@SW_SHOW, $p_gui)

	HotKeySet("{Esc}", "Player_Close")

	Dim $PlayerData[4]
	If Not FileExists($KonfFile) Then
		If Not Optionen() Then Player_Close()
	EndIf

	$PlayerData[0] = IniRead($KonfFile, "Settings", "AbstandW", "")
	$PlayerData[1] = IniRead($KonfFile, "Settings", "AbstandZ", "")
	$PlayerData[2] = StringLeft(IniRead($KonfFile, "Settings", "Return", ""), 1)
	If $PlayerData[2] = 2 Then $PlayerData[3] = StringTrimLeft(IniRead($KonfFile, "Settings", "Return", ""), 1)

	Switch $PlayerData[2]
		Case 1
			$Modus = "Optische wiedergabe"
		Case 2
			$Modus = "Systembeeper wiedergabe"
		Case 3
			$Modus = "Systemlautsprecher wiedergabe"
	EndSwitch

	$MorseCode = StringSplit($MorseCode, "")
	For $x = 1 To $MorseCode[0]
		If $Exit Then
			$Exit = 0
			ExitLoop
		EndIf
		Switch $PlayerData[2]
			Case 2
				Sleep($PlayerData[1] + 50)
			Case 3
				Sleep($PlayerData[1])
		EndSwitch
		Switch $MorseCode[$x]
			Case "."
				Switch $PlayerData[2]
					Case 3
						_ResourcePlaySound("SHORT", 0, $Res_DLL)
					Case 2
						Beep($PlayerData[3], 150)
					Case 1
						GUICtrlSetImage($Optisch, "light.jpg")
						Sleep(100)
						GUICtrlSetImage($Optisch, "")
						Sleep(100)
				EndSwitch
				GUICtrlSetData($Info, "Aktuelles Zeichen:" & $MorseCode[$x] & @CRLF & "Zeichen verbleibend:" & UBound($MorseCode) - $x & @CRLF & "Modus:" & $Modus)
			Case "_"
				Switch $PlayerData[2]
					Case 3
						_ResourcePlaySound("LONG", 0, $Res_DLL)
					Case 2
						Beep($PlayerData[3], 350)
					Case 1
						GUICtrlSetImage($Optisch, "light.jpg")
						Sleep(500)
						GUICtrlSetImage($Optisch, "")
						Sleep(200)
				EndSwitch
				GUICtrlSetData($Info, "Aktuelles Zeichen:" & $MorseCode[$x] & @CRLF & "Zeichen verbleibend:" & UBound($MorseCode) - $x & @CRLF & "Modus:" & $Modus)
			Case "|"
				Sleep($PlayerData[0])
		EndSwitch
		GUICtrlSetData($Fortschritt, ($x * 100) / $MorseCode[0])
		GUICtrlSetData($tFortschritt, Int(($x * 100) / $MorseCode[0]) & "%")
	Next
	HotKeySet("{Esc}")
	GUIDelete($p_gui)
	AdlibRegister("Convert", $ADLIBTime)
	GUISetState(@SW_UNLOCK, $gui)
EndFunc   ;==>MorsePlayer

Func Player_Close()
	$Exit = 1
EndFunc   ;==>Player_Close
; thanks Larry,ProgAndy
; MSDN: http://msdn2.microsoft.com/en-us/library/ms712879.aspx
Func _ResourcePlaySound($ResName = -1, $Flag = -1, $hDLL = -1)
	DllCall("winmm.dll", "int", "PlaySound", "str", $ResName, "hwnd", $hDLL, "int", BitOR(0x00040004, $Flag))
EndFunc   ;==>_ResourcePlaySound

Func Optionen()
	AdlibUnRegister("Convert")
	Opt("GuiOnEventMode", 0)
	GUISetState(@SW_LOCK, $gui)

	$e_gui = GUICreate("Optionen", 241, 550, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION, $WS_POPUP, $WS_POPUPWINDOW, $WS_BORDER, $WS_CLIPSIBLINGS), $WS_EX_TOOLWINDOW, $gui)
	GUICtrlCreateGroup("Abstnde", 8, 8, 225, 369)
	$Abstand_Woerter = GUICtrlCreateSlider(40, 48, 38, 253, BitOR($TBS_VERT, $TBS_AUTOTICKS, $TBS_TOP, $TBS_LEFT, $TBS_FIXEDLENGTH))
	GUICtrlSetLimit(-1, 1000, 0)
	GUICtrlSetData(-1, 500)
	$Abstand_Zeichen = GUICtrlCreateSlider(136, 48, 38, 253, BitOR($TBS_VERT, $TBS_AUTOTICKS, $TBS_TOP, $TBS_LEFT, $TBS_FIXEDLENGTH))
	GUICtrlSetLimit(-1, 1000, 0)
	GUICtrlCreateLabel("Zeichen", 136, 32, 50, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Wrter", 40, 32, 42, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$Abstand_Zeichen_Label = GUICtrlCreateInput("", 120, 304, 81, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY), 0)
	$Abstand_Woerter_Label = GUICtrlCreateInput("", 19, 303, 81, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY), 0)
	$Speed = GUICtrlCreateCombo("", 57, 338, 164, 25)
	GUICtrlSetData(-1, "Langsam|Normal|Schnell|Extrem")
	GUICtrlCreateLabel("Speed:", 16, 340, 38, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$Save_Exit = GUICtrlCreateButton("OK", 8, 520, 105, 25)
	GUICtrlCreateGroup("Ausgabe", 8, 384, 225, 129)
	GUICtrlCreateLabel("Hz", 141, 482, 17, 17)
	$SysReturn_Hz = GUICtrlCreateInput("37", 89, 479, 70, 21, $ES_NUMBER)
	$SysReturn = GUICtrlCreateRadio("Systemlautsprecher", 17, 455, 113, 17)
	$Optisch_Return = GUICtrlCreateRadio("Optisch", 17, 407, 65, 17)
	$Akustisch_Return = GUICtrlCreateRadio("Sounds", 17, 431, 57, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$Abbrechen = GUICtrlCreateButton("Abbrechen", 125, 520, 105, 25, 0)


	If Not FileExists($KonfFile) Then
		GUICtrlSetState($Akustisch_Return, $GUI_CHECKED)
		GUICtrlSetData($Abstand_Woerter, 100)
		GUICtrlSetData($Abstand_Woerter_Label, 100 & " ms")
		GUICtrlSetData($Abstand_Zeichen, 25)
		GUICtrlSetData($Abstand_Zeichen_Label, 25 & " ms")
	Else
		GUICtrlSetData($Abstand_Woerter, IniRead($KonfFile, "Settings", "AbstandW", ""))
		GUICtrlSetData($Abstand_Zeichen, IniRead($KonfFile, "Settings", "AbstandZ", ""))
		Switch StringLeft(IniRead($KonfFile, "Settings", "Return", ""), 1)
			Case 1
				GUICtrlSetState($Optisch_Return, $GUI_CHECKED)
			Case 2
				GUICtrlSetState($SysReturn, $GUI_CHECKED)
				GUICtrlSetData($SysReturn_Hz, StringTrimLeft(IniRead($KonfFile, "Settings", "Return", ""), 1))
			Case 3
				GUICtrlSetState($Akustisch_Return, $GUI_CHECKED)
		EndSwitch
	EndIf

	AdlibRegister("UpdateOpt", 100)
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				AdlibUnRegister("UpdateOpt")
				AdlibRegister("Convert", $ADLIBTime)
				Opt("GuiOnEventMode", 1)
				GUIDelete($e_gui)
				GUISetState(@SW_UNLOCK, $gui)
				Return 0
			Case $Speed
				$Speed_Read = GUICtrlRead($Speed)
				Switch $Speed_Read
					Case "Langsam"
						GUICtrlSetData($Abstand_Woerter, 500)
						GUICtrlSetData($Abstand_Zeichen, 100)
					Case "Normal"
						GUICtrlSetData($Abstand_Woerter, 200)
						GUICtrlSetData($Abstand_Zeichen, 50)
					Case "Schnell"
						GUICtrlSetData($Abstand_Woerter, 100)
						GUICtrlSetData($Abstand_Zeichen, 25)
					Case "Extrem"
						GUICtrlSetData($Abstand_Woerter, 50)
						GUICtrlSetData($Abstand_Zeichen, 10)
				EndSwitch
			Case $Save_Exit
				If GUICtrlRead($Optisch_Return) = $GUI_CHECKED Then IniWrite($KonfFile, "Settings", "Return", 1)
				If GUICtrlRead($SysReturn) = $GUI_CHECKED Then IniWrite($KonfFile, "Settings", "Return", 2 & GUICtrlRead($SysReturn_Hz))
				If GUICtrlRead($Akustisch_Return) = $GUI_CHECKED Then IniWrite($KonfFile, "Settings", "Return", 3)
				IniWrite($KonfFile, "Settings", "AbstandW", GUICtrlRead($Abstand_Woerter))
				IniWrite($KonfFile, "Settings", "AbstandZ", GUICtrlRead($Abstand_Zeichen))
				AdlibUnRegister("UpdateOpt")
				AdlibRegister("Convert", $ADLIBTime)
				Opt("GuiOnEventMode", 1)
				GUIDelete($e_gui)
				GUISetState(@SW_UNLOCK, $gui)
				Return 1
			Case $Abbrechen
				AdlibUnRegister("UpdateOpt")
				AdlibRegister("Convert", $ADLIBTime)
				Opt("GuiOnEventMode", 1)
				GUIDelete($e_gui)
				GUISetState(@SW_UNLOCK, $gui)
				Return 0
		EndSwitch
	WEnd
EndFunc   ;==>Optionen


Func UpdateOpt()
	GUICtrlSetData($Abstand_Woerter_Label, GUICtrlRead($Abstand_Woerter) & " ms")
	GUICtrlSetData($Abstand_Zeichen_Label, GUICtrlRead($Abstand_Zeichen) & " ms")
EndFunc   ;==>UpdateOpt
